## ros-eloquent-rclcpp-components 0.8.5

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(rclcpp_components)

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()
if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

find_package(ament_cmake_ros REQUIRED)
find_package(ament_index_cpp REQUIRED)
find_package(class_loader REQUIRED)
find_package(composition_interfaces REQUIRED)
find_package(rclcpp REQUIRED)
find_package(rcpputils REQUIRED)

include_directories(include)

add_library(
  component_manager
  STATIC
  src/component_manager.cpp
)
ament_target_dependencies(component_manager
  "ament_index_cpp"
  "class_loader"
  "composition_interfaces"
  "rclcpp"
  "rcpputils"
)

add_executable(
  component_container
  src/component_container.cpp
)
target_link_libraries(component_container component_manager)
ament_target_dependencies(component_container
  "rclcpp"
)

set(node_main_template_install_dir "share/${PROJECT_NAME}")
install(FILES
  src/node_main.cpp.in
  DESTINATION ${node_main_template_install_dir})

add_executable(
  component_container_mt
  src/component_container_mt.cpp
)
target_link_libraries(component_container_mt component_manager)
ament_target_dependencies(component_container_mt
  "rclcpp"
)

if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
  target_link_libraries(component_container "stdc++fs")
  target_link_libraries(component_container_mt "stdc++fs")
endif()

if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  ament_lint_auto_find_test_dependencies()

  set(components "")
  add_library(test_component SHARED test/components/test_component.cpp)
  ament_target_dependencies(test_component
    "class_loader"
    "rclcpp")
  #rclcpp_components_register_nodes(test_component "test_rclcpp_components::TestComponent")
  set(components "${components}test_rclcpp_components::TestComponentFoo;$<TARGET_FILE:test_component>\n")
  set(components "${components}test_rclcpp_components::TestComponentBar;$<TARGET_FILE:test_component>\n")
  set(components "${components}test_rclcpp_components::TestComponentNoNode;$<TARGET_FILE:test_component>\n")

  file(GENERATE
    OUTPUT
    "${CMAKE_CURRENT_BINARY_DIR}/test_ament_index/$<CONFIG>/share/ament_index/resource_index/rclcpp_components/${PROJECT_NAME}"
    CONTENT "${components}")

  set(append_library_dirs "${CMAKE_CURRENT_BINARY_DIR}")
  if(WIN32)
    set(append_library_dirs "${append_library_dirs}/$<CONFIG>")
  endif()

  ament_add_gtest(test_component_manager test/test_component_manager.cpp
    APPEND_ENV AMENT_PREFIX_PATH=${CMAKE_CURRENT_BINARY_DIR}/test_ament_index/$<CONFIG>
    APPEND_LIBRARY_DIRS "${append_library_dirs}")
  if(TARGET test_component_manager)
    target_link_libraries(test_component_manager component_manager)
    target_include_directories(test_component_manager PRIVATE src)
  endif()

  ament_add_gtest(test_component_manager_api test/test_component_manager_api.cpp
    APPEND_ENV AMENT_PREFIX_PATH=${CMAKE_CURRENT_BINARY_DIR}/test_ament_index/$<CONFIG>
    APPEND_LIBRARY_DIRS "${append_library_dirs}")
  if(TARGET test_component_manager_api)
    target_link_libraries(test_component_manager_api component_manager)
    target_include_directories(test_component_manager_api PRIVATE src)
  endif()
endif()

# Install executables
install(
  TARGETS component_container component_container_mt
  RUNTIME DESTINATION lib/${PROJECT_NAME}
)

# Install include directories
install(
  DIRECTORY include/
  DESTINATION include
)

# Install cmake
install(
  DIRECTORY cmake
  DESTINATION share/${PROJECT_NAME}
)

# specific order: dependents before dependencies
ament_export_include_directories(include)
ament_export_dependencies(class_loader)
ament_export_dependencies(rclcpp)
ament_package(CONFIG_EXTRAS rclcpp_components-extras.cmake.in)

=== debian/changelog ===
ros-eloquent-rclcpp-components (0.8.5-1bionic) bionic; urgency=high

  * Added rclcpp_components Doxyfile (#1091 <https://github.com/ros2/rclcpp/issues/1091>) (#1200 <https://github.com/ros2/rclcpp/issues/1200>)
  * Contributors: Alejandro Hernández Cordero

 -- Michael Carroll <michael@openrobotics.org>  Fri, 04 Dec 2020 06:00:00 -0000

ros-eloquent-rclcpp-components (0.8.4-1bionic) bionic; urgency=high

  * Remove absolute path from installed CMake code (#948 <https://github.com/ros2/rclcpp/issues/948>) (#950 <https://github.com/ros2/rclcpp/issues/950>)
  * Contributors: Jacob Perron

 -- Michael Carroll <michael@openrobotics.org>  Fri, 17 Jan 2020 06:00:00 -0000

ros-eloquent-rclcpp-components (0.8.3-1bionic) bionic; urgency=high



 -- Michael Carroll <michael@openrobotics.org>  Tue, 19 Nov 2019 06:00:00 -0000

ros-eloquent-rclcpp-components (0.8.2-1bionic) bionic; urgency=high



 -- Michael Carroll <michael@openrobotics.org>  Mon, 18 Nov 2019 06:00:00 -0000

ros-eloquent-rclcpp-components (0.8.1-1bionic) bionic; urgency=high

  * Enable intra-process comm via LoadNode request. (#871 <https://github.com/ros2/rclcpp/issues/871>)
  * Aggregate all component manager API tests. (#876 <https://github.com/ros2/rclcpp/issues/876>)
  * Contributors: Michel Hidalgo

 -- Michael Carroll <michael@openrobotics.org>  Wed, 23 Oct 2019 05:00:00 -0000

ros-eloquent-rclcpp-components (0.8.0-1bionic) bionic; urgency=high

  * Force explicit --ros-args in NodeOptions::arguments(). (#845 <https://github.com/ros2/rclcpp/issues/845>)
  * Use of -r/--remap flags where appropriate. (#834 <https://github.com/ros2/rclcpp/issues/834>)
  * Add line break after first open paren in multiline function call (#785 <https://github.com/ros2/rclcpp/issues/785>)
  * fix linter issue (#795 <https://github.com/ros2/rclcpp/issues/795>)
  * Remove non-package from ament_target_dependencies() (#793 <https://github.com/ros2/rclcpp/issues/793>)
  * fix for multiple nodes not being recognized (#790 <https://github.com/ros2/rclcpp/issues/790>)
  * Cmake infrastructure for creating components (#784 <https://github.com/ros2/rclcpp/issues/784>)
  * Contributors: Dan Rose, Michel Hidalgo, Shane Loretz, Siddharth Kucheria

 -- Michael Carroll <michael@openrobotics.org>  Thu, 26 Sep 2019 05:00:00 -0000

ros-eloquent-rclcpp-components (0.7.5-1bionic) bionic; urgency=high



 -- Michael Carroll <michael@openrobotics.org>  Thu, 30 May 2019 05:00:00 -0000

ros-eloquent-rclcpp-components (0.7.4-1bionic) bionic; urgency=high

  * Rename parameter options (#745 <https://github.com/ros2/rclcpp/issues/745>)
  * don't use global arguments for components loaded into the manager (#736 <https://github.com/ros2/rclcpp/issues/736>)
  * Contributors: Dirk Thomas, William Woodall

 -- Michael Carroll <michael@openrobotics.org>  Wed, 29 May 2019 05:00:00 -0000

ros-eloquent-rclcpp-components (0.7.3-1bionic) bionic; urgency=high



 -- Michael Carroll <michael@openrobotics.org>  Mon, 20 May 2019 05:00:00 -0000

ros-eloquent-rclcpp-components (0.7.2-1bionic) bionic; urgency=high

  * Updated to support changes to ``Node::get_node_names()``. (#698 <https://github.com/ros2/rclcpp/issues/698>)
  * Contributors: jhdcs

 -- Michael Carroll <michael@openrobotics.org>  Wed, 08 May 2019 05:00:00 -0000

ros-eloquent-rclcpp-components (0.7.1-1bionic) bionic; urgency=high



 -- Michael Carroll <michael@openrobotics.org>  Fri, 26 Apr 2019 05:00:00 -0000

ros-eloquent-rclcpp-components (0.7.0-1bionic) bionic; urgency=high

  * Introduce rclcpp_components to implement composition (#665 <https://github.com/ros2/rclcpp/issues/665>)
  * Contributors: Michael Carroll

 -- Michael Carroll <michael@openrobotics.org>  Sun, 14 Apr 2019 05:00:00 -0000

ros-eloquent-rclcpp-components (0.6.2-1bionic) bionic; urgency=high



 -- Michael Carroll <michael@openrobotics.org>  Wed, 12 Dec 2018 06:00:00 -0000

ros-eloquent-rclcpp-components (0.6.1-1bionic) bionic; urgency=high



 -- Michael Carroll <michael@openrobotics.org>  Thu, 06 Dec 2018 06:00:00 -0000

ros-eloquent-rclcpp-components (0.6.0-1bionic) bionic; urgency=high



 -- Michael Carroll <michael@openrobotics.org>  Mon, 19 Nov 2018 06:00:00 -0000

ros-eloquent-rclcpp-components (0.5.1-1bionic) bionic; urgency=high



 -- Michael Carroll <michael@openrobotics.org>  Thu, 28 Jun 2018 05:00:00 -0000

ros-eloquent-rclcpp-components (0.5.0-1bionic) bionic; urgency=high



 -- Michael Carroll <michael@openrobotics.org>  Mon, 25 Jun 2018 05:00:00 -0000

ros-eloquent-rclcpp-components (0.4.0-1bionic) bionic; urgency=high



 -- Michael Carroll <michael@openrobotics.org>  Fri, 08 Dec 2017 06:00:00 -0000

=== debian/control ===
Source: ros-eloquent-rclcpp-components
Section: misc
Priority: optional
Maintainer: Michael Carroll <michael@openrobotics.org>
Build-Depends: debhelper (>= 9.0.0), ros-eloquent-ament-cmake-gtest, ros-eloquent-ament-cmake-ros, ros-eloquent-ament-index-cpp, ros-eloquent-ament-lint-auto, ros-eloquent-ament-lint-common, ros-eloquent-class-loader, ros-eloquent-composition-interfaces, ros-eloquent-launch-testing, ros-eloquent-rclcpp, ros-eloquent-rcpputils, ros-eloquent-std-msgs, ros-eloquent-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-eloquent-rclcpp-components
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-eloquent-ament-index-cpp, ros-eloquent-class-loader, ros-eloquent-composition-interfaces, ros-eloquent-rclcpp, ros-eloquent-ros-workspace
Description: Package containing tools for dynamically loadable components

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/eloquent/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/eloquent/setup.sh" ]; then . "/opt/ros/eloquent/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/eloquent" \
		-DAMENT_PREFIX_PATH="/opt/ros/eloquent" \
		-DCMAKE_PREFIX_PATH="/opt/ros/eloquent"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/eloquent/setup.sh" ]; then . "/opt/ros/eloquent/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/eloquent/setup.sh" ]; then . "/opt/ros/eloquent/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/eloquent/setup.sh" ]; then . "/opt/ros/eloquent/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-eloquent-rclcpp-components//opt/ros/eloquent/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/eloquent/setup.sh" ]; then . "/opt/ros/eloquent/setup.sh"; fi && \
	dh_auto_install
